//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be perfomring new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you
//---------------------------------------------------------------------------
// USERES("invertFunc.res");
//---------------------------------------------------------------------------
#include "danImage.h"
#include <math.h>

#define MIN( a, b ) ((a)<(b) ? (a) : (b))

#define currPixelX 10
#define currPixelY 10

//---------------------------------------------------------------------------

extern "C" __declspec(dllexport) char *getName();
extern "C" __declspec(dllexport) char *getInfo();
extern "C" __declspec(dllexport) danImage *filterFunction(danImage *src);

float RiBoxFilter(float, float, float, float);

// Specify Name & Description (no more than 20 characters!!
char name[21] = "Box Filter";
char desc[21] = "Basic Quick Filter";

//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
        return 1;
}
//---------------------------------------------------------------------------
char *getName()
{
        return name;
}

char *getInfo()
{
        return desc;
}


// LOOPING FUNCTION WITH BOX BLUR FUNCTION

danImage *filterFunction(danImage *src)
{
    danImage *temp;
    double d;
    double x,y,i,j;

// this section can be modified: By increasing the filters width and height
// you can increase the amount of blurring

    double filterWidth = 3.;   //pixelwidth -1
    double filterHeight = 3.;  //pixelwidth -1

    double sampleIncrement = 1;

    temp = new danImage;

    // default terminology for Windows/Borland C++

    temp->setWidth(src->getWidth());
    temp->setHeight(src->getHeight());

    // NOTE:
    // i : X Position in Dest Image
    // j : Y Position in Dest Image
    // x : X Position in Filter (Sample Space)
    // y : Y Position in Filter (Sample Space)



    //Cycles through source image width and height line by line
    //from left most pixel to right most pixel

for (i=0; i<src->getWidth(); i++)
for (j=0; j<src->getHeight(); j++)
{
        double totalR = 0;              //initial RGB and increment value
        double totalG = 0;              // COUNTER CONTROLLED REPETITION!
        double totalB = 0;
        double noPix = 0;

    for (x = -(filterWidth/2); x <= filterWidth/2; x+=sampleIncrement)
    for (y = -(filterHeight/2); y <= filterHeight/2; y+=sampleIncrement)
    {

        if (((floor(i+x)>=0) && (floor(j+y)>=0)) && ((floor(i+x)<src->getWidth()) && (floor(j+y)<src->getHeight())))
        {

            d = 0;

            d = RiBoxFilter(x,y,filterWidth,filterHeight);

        //For every value of 'd' gets RGB value and increments to next pixel


        if (d>0)
        {
                totalR += d*((double)src->getPixelRed( (floor(i+x)),(floor(j+y)) ) );
                totalG += d*((double)src->getPixelGreen( (floor(i+x)),(floor(j+y)) ) );
                totalB += d*((double)src->getPixelBlue( (floor(i+x)),(floor(j+y)) ) );
                noPix +=d;
        }

            // Origin in sample space corresponds to the current pixel
            // being looked at.
            // E.g If we are working on Pixel[10,10]
            //     The middle of pixel[10,10] would correspond
            //	   to 0,0 in sample space.

        }
   }

// SET PIXEL WITH AVERAGE
// ACTUAL BLURRING OF PIXEL VALUES


    temp->setPixel(i,j,
                        (int)(totalR/noPix),
                        (int)(totalG/noPix),
                        (int)(totalB/noPix)
                                );

}

    return temp;
}


//---------------------------------------------------------------------------

//BOX FILTER DEFINITION


float RiBoxFilter(float x, float y, float xwidth, float ywidth)


{
	return MIN((fabs(x) <= xwidth/2. ? 1. : 0.),
    			(fabs(y) <= ywidth/2. ? 1. : 0.) );
}

