//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------

#include "../danImage.h"
#include <math.h>

#define MIN( a, b ) ((a)<(b) ? (a) : (b))

#define currPixelX 10
#define currPixelY 10

//---------------------------------------------------------------------------

extern "C" __declspec(dllexport) char *getName();
extern "C" __declspec(dllexport) char *getInfo();
extern "C" __declspec(dllexport) danImage *filterFunction(danImage *src);

float RiBoxFilter(float, float, float, float);

// Specify Name & Description 

char name[21] = "Box02";
char desc[21] = "5 Pixels Wide";

//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
        return 1;
}
//---------------------------------------------------------------------------
char *getName()
{
        return name;
}

char *getInfo()
{
        return desc;
}




danImage *filterFunction(danImage *src)
{
    danImage *temp;
    double d;
    double x,y,i,j;



    double filterWidth = 5.;   //pixelwidth -1
    double filterHeight = 5.;  //pixelwidth -1

    double sampleIncrement = 1;

    temp = new danImage;



    temp->setWidth(src->getWidth());
    temp->setHeight(src->getHeight());






for (i=0; i<src->getWidth(); i++)
for (j=0; j<src->getHeight(); j++)
{
        double totalR = 0;
        double totalG = 0;
        double totalB = 0;
        double noPix = 0;

    for (x = -(filterWidth/2); x <= filterWidth/2; x+=sampleIncrement)
    for (y = -(filterHeight/2); y <= filterHeight/2; y+=sampleIncrement)
    {

        if (((floor(i+x)>=0) && (floor(j+y)>=0)) && ((floor(i+x)<src->getWidth()) && (floor(j+y)<src->getHeight())))
        {

            d = 0;

            d = RiBoxFilter(x,y,filterWidth,filterHeight);

        //For every value of 'd' gets RGB value and increments to next pixel


        if (d>0)
        {
                totalR += d*((double)src->getPixelRed( (floor(i+x)),(floor(j+y)) ) );
                totalG += d*((double)src->getPixelGreen( (floor(i+x)),(floor(j+y)) ) );
                totalB += d*((double)src->getPixelBlue( (floor(i+x)),(floor(j+y)) ) );
                noPix +=d;
        }


        }
   }

// SET PIXEL WITH AVERAGE
// ACTUAL BLURRING OF PIXEL VALUES


    temp->setPixel(i,j,
                        (int)(totalR/noPix),
                        (int)(totalG/noPix),
                        (int)(totalB/noPix)
                                );

}

    return temp;
}


//---------------------------------------------------------------------------

//BOX FILTER DEFINITION


float RiBoxFilter(float x, float y, float xwidth, float ywidth)


{
	return MIN((fabs(x) <= xwidth/2. ? 1. : 0.),
    			(fabs(y) <= ywidth/2. ? 1. : 0.) );
}

