//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------

#include "../danImage.h"
#include <math.h>

#define MIN( a, b ) ((a)<(b) ? (a) : (b))

#define currPixelX 10
#define currPixelY 10

//---------------------------------------------------------------------------

extern "C" __declspec(dllexport) char *getName();
extern "C" __declspec(dllexport) char *getInfo();
extern "C" __declspec(dllexport) danImage *filterFunction(danImage *src);

float RiSincFilter(float, float, float, float);

// Specify Name & Description (no more than 20 characters!!
char name[21] = "Sinc02";
char desc[21] = "5 pixels wide";

//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
        return 1;
}
//---------------------------------------------------------------------------
char *getName()
{
        return name;
}

char *getInfo()
{
        return desc;
}

danImage *filterFunction(danImage *src)
{
    danImage *temp;
    double d;
    double x,y,i,j;

    double filterWidth = 5.;   //pixelwidth -1
    double filterHeight = 5.;  //pixelwidth -1

    double sampleIncrement = 1;

    temp = new danImage;

    temp->setWidth(src->getWidth());
    temp->setHeight(src->getHeight());

    // NOTE:
    // i : X Position in Dest Image
    // j : Y Position in Dest Image
    // x : X Position in Filter (Sample Space)
    // y : Y Position in Filter (Sample Space)


    // Apologies for the awful code layout
    // Its shit...

for (i=0; i<src->getWidth(); i++)
for (j=0; j<src->getHeight(); j++)
{
        double totalR = 0;
        double totalG = 0;
        double totalB = 0;
        double noPix = 0;

    for (x = -(filterWidth/2); x <= filterWidth/2; x+=sampleIncrement)
    for (y = -(filterHeight/2); y <= filterHeight/2; y+=sampleIncrement)
    {

        if (((floor(i+x)>=0) && (floor(j+y)>=0)) && ((floor(i+x)<src->getWidth()) && (floor(j+y)<src->getHeight())))
        {

            d = 0;

          d = RiSincFilter(x,y,filterWidth, filterHeight);

        if (d>0)
        {
                totalR += d*((double)src->getPixelRed( (floor(i+x)),(floor(j+y)) ) );
                totalG += d*((double)src->getPixelGreen( (floor(i+x)),(floor(j+y)) ) );
                totalB += d*((double)src->getPixelBlue( (floor(i+x)),(floor(j+y)) ) );
                noPix +=d;
        }

            // Origin in sample space corresponds to the current pixel
            // being looked at.
            // E.g If we are working on Pixel[10,10]
            //     The middle of pixel[10,10] would correspond
            //	   to 0,0 in sample space.

        }
   }

// SET PIXEL WITH AVERAGE
    temp->setPixel(i,j,
                        (int)(totalR/noPix),
                        (int)(totalG/noPix),
                        (int)(totalB/noPix)
                                );

//         temp->setPixel(i,j,src->getPixelRed(i,j),src->getPixelRed(i,j),src->getPixelGreen(i,j));

        // result = total / noPix;


}

    return temp;
}
//---------------------------------------------------------------------------

float RiSincFilter(float x, float y, float xwidth, float ywidth)
{
	double d;

    d = sqrt(x*x+y*y);
    if (d!=0)
    	return sin(d)/(d);
    else
    	return 1.0;
}
