//---------------------------------------------------------------------------
#include <vcl.h>
#include<stdio.h>
#include<dir.h>
#include<string.h>
#pragma hdrstop

#include "filterEngineUnit1.h"
#include "filterEngineUnit2.h"
#include "filterEngineUnit3.h"
#include "filterEngineUnit4.h"
#include "danImage.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

int loadFilterFunction(char *filename);
void freeFilterFunc();

TForm1 *Form1;
HINSTANCE hinstLib;

typedef char * (*INFOPROC)();
typedef danImage * (*IMGPROC)(danImage *);
INFOPROC infoProc;
INFOPROC nameProc;
IMGPROC imgProc;

char currDir[MAXPATH];

danImage *srcImage, *dstImage;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        srcImage = new danImage;
        dstImage = new danImage;
}
//---------------------------------------------------------------------------
int loadFilterFunc(char *filename)
{
        // Get a handle to the DLL library
        hinstLib = LoadLibrary(filename);

        //Load Failed
        if (hinstLib == NULL) return 0;

        //Get handle & pointer for function in DLL
        nameProc = (INFOPROC) GetProcAddress(hinstLib, "_getName");
        infoProc = (INFOPROC) GetProcAddress(hinstLib, "_getInfo");
        imgProc = (IMGPROC) GetProcAddress(hinstLib, "_filterFunction");

        // Pointer Successful
        if (nameProc == NULL) return 0;
        if (infoProc == NULL) return 0;
        if (imgProc == NULL) return 0;

        return 1;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
        OpenPictureDialog1->FileName="*.bmp";
        OpenPictureDialog1->Filter="*.bmp";
        if (OpenPictureDialog1->Execute()==True)
        {
                Form2->Image1->Picture->LoadFromFile(OpenPictureDialog1->FileName);
                srcImage->setPic(Form2->Image1->Picture);
                srcImage->setSpp(3);
                srcImage->setBps(8);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{

        OpenDialog1->FileName="*.dll";
        OpenDialog1->Filter="*.dll";
        if (OpenDialog1->Execute()==True)
                if (loadFilterFunc(OpenDialog1->FileName.c_str()))
                {
                        Label4->Caption = "Filter Loaded";
                        Label8->Caption = nameProc();
                        Label9->Caption = infoProc();
                }
                else
                        Label4->Caption = "Filter Failed";
}
//---------------------------------------------------------------------------





void __fastcall TForm1::FormShow(TObject *Sender)
{
        Label8->Caption = "";
        Label9->Caption = "";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton6Click(TObject *Sender)
{
     FreeLibrary(hinstLib);
     Label4->Caption = "No Filter Loaded";
     Label8->Caption = "";
     Label9->Caption = "";
}
//---------------------------------------------------------------------------



void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
        if (srcImage->getSpp()==0)
        {
        }
        else
        {
                SavePictureDialog1->FileName="*.bmp";
                SavePictureDialog1->Filter="*.bmp";
                if (SavePictureDialog1->Execute()==True)
                {
                        int tempLength = SavePictureDialog1->FileName.Length();
                        AnsiString sub = SavePictureDialog1->FileName.SubString(tempLength-3,4);

                        if (sub!=".bmp")
                                dstImage->getPic()->SaveToFile(SavePictureDialog1->FileName+".bmp");
                        else
                                dstImage->getPic()->SaveToFile(SavePictureDialog1->FileName);
                }
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton4Click(TObject *Sender)
{
        if (srcImage->getSpp()==0)
        {
        }
        else
        {
            Form2->Image1->Picture = srcImage->getPic();
            Form2->Image1->Width = srcImage->getWidth();
            Form2->Image1->Height = srcImage->getHeight();
            Form2->Width = Form2->Image1->Width + 20;
            Form2->Height = Form2->Image1->Height + 40;
            Form2->Show();
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton5Click(TObject *Sender)
{
        if (dstImage->getSpp()==0)
        {
        }
        else
        {
            Form3->Image1->Picture = dstImage->getPic();
            Form3->Image1->Width = dstImage->getWidth();
            Form3->Image1->Height = dstImage->getHeight();
            Form3->Width = Form3->Image1->Width + 20;
            Form3->Height = Form3->Image1->Height + 40;
            Form3->Show();
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
        if (srcImage->getSpp()==0)
        {
           Application->MessageBox("Please specify an Input Image", "Render...", MB_OK);
           return;
        }

        if (hinstLib==NULL)
        {
           Application->MessageBox("Please specify a Filter", "Render...", MB_OK);
           return;
        }

        Screen->Cursor = -11;

        dstImage = imgProc(srcImage);
        dstImage->setSpp(srcImage->getSpp());
        dstImage->setBps(dstImage->getBps());

        if (dstImage->getSpp()==0)
        {
        }
        else
        {
        Image2->Picture = dstImage->getPic();
            Form3->Image1->Picture = dstImage->getPic();
            Form3->Image1->Width = dstImage->getWidth();
            Form3->Image1->Height = dstImage->getHeight();
            Form3->Width = Form3->Image1->Width + 20;
            Form3->Height = Form3->Image1->Height + 40;
        }


        Screen->Cursor = 0;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
        Form2->Hide();
        Form3->Hide();        
}
//---------------------------------------------------------------------------


void __fastcall TForm1::OpenInputImage1Click(TObject *Sender)
{
        OpenPictureDialog1->FileName="*.bmp";
        OpenPictureDialog1->Filter="*.bmp";
        if (OpenPictureDialog1->Execute()==True)
        {
                Image1->Picture->LoadFromFile(OpenPictureDialog1->FileName);
                Form2->Image1->Picture->LoadFromFile(OpenPictureDialog1->FileName);
                srcImage->setPic(Form2->Image1->Picture);
                srcImage->setSpp(3);
                srcImage->setBps(8);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RenderOutput1Click(TObject *Sender)
{
        if (dstImage->getSpp()==0)
        {
                Application->MessageBox("Please Render an Output Image", "Save Output Image...", MB_OK);
                return;
       }
        else
        {       
                SavePictureDialog1->FileName="*.bmp";
                SavePictureDialog1->Filter="*.bmp";
                if (SavePictureDialog1->Execute()==True)
                {
                        int tempLength = SavePictureDialog1->FileName.Length();
                        AnsiString sub = SavePictureDialog1->FileName.SubString(tempLength-3,4);

                        if (sub!=".bmp")
                                dstImage->getPic()->SaveToFile(SavePictureDialog1->FileName+".bmp");
                        else
                                dstImage->getPic()->SaveToFile(SavePictureDialog1->FileName);
                }
        }        
}
//---------------------------------------------------------------------------





void __fastcall TForm1::Image1Click(TObject *Sender)
{
        if (srcImage->getSpp()==0)
        {
        }
        else
        {
            Form2->Image1->Picture = srcImage->getPic();
            Form2->Image1->Width = srcImage->getWidth();
            Form2->Image1->Height = srcImage->getHeight();
            Form2->Width = Form2->Image1->Width + 20;
            Form2->Height = Form2->Image1->Height + 40;
            Form2->Show();
        }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Shape4MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        if (Form2->Visible==True)
                Form2->Hide();
        else
        if (srcImage->getSpp()==0)
        {
        }
        else
        {
            Form2->Image1->Picture = srcImage->getPic();
            Form2->Image1->Width = srcImage->getWidth();
            Form2->Image1->Height = srcImage->getHeight();
            Form2->Width = Form2->Image1->Width + 20;
            Form2->Height = Form2->Image1->Height + 40;
            Form2->Show();
        }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::UnloadFilter1Click(TObject *Sender)
{
     FreeLibrary(hinstLib);
     hinstLib=NULL;
     Label4->Caption = "No Filter Loaded";
     Label8->Caption = "";
     Label9->Caption = "";        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LoadFilter1Click(TObject *Sender)
{
        char *newDir = strcat(currDir, "\\Filters");
        OpenDialog1->InitialDir=  newDir;
        OpenDialog1->FileName="*.dll";
        OpenDialog1->Filter="*.dll";
        if (OpenDialog1->Execute()==True)
                if (loadFilterFunc(OpenDialog1->FileName.c_str()))
                {
                        Label4->Caption = "Filter Loaded";
                        Label8->Caption = nameProc();
                        Label9->Caption = infoProc();
                }
                else
                {
                        Application->MessageBox("Filter Load Failed!", "Load Filter...", MB_OK);
                        Label4->Caption = "No Filter Loaded";
                }
        
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Shape5MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        if (Form3->Visible==True)
                Form3->Hide();
        else
        if (dstImage->getSpp()==0)
        {
        }
        else
        {
            Form3->Image1->Picture = dstImage->getPic();
            Form3->Image1->Width = dstImage->getWidth();
            Form3->Image1->Height = dstImage->getHeight();
            Form3->Width = Form3->Image1->Width + 20;
            Form3->Height = Form3->Image1->Height + 40;
            Form3->Show();
        }        
}
//---------------------------------------------------------------------------





void __fastcall TForm1::About1Click(TObject *Sender)
{
        Form4->Show();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
        getcwd(currDir, MAXPATH);       
}
//---------------------------------------------------------------------------

